/**********************************************/
/*         Drive Information Utility
/*          by Edans Flavius - 2002
/*              snade@ig.com.br
/* 
/*
/* Description: This program shows information
/*   about all logical drives available. It shows 
/*   the following items:
/*		- bytes per sector
/*		- sectors per cluster
/*		- bytes por cluster
/*
/*
/**********************************************/

#include <windows.h>
#include <conio.h>
#include <stdio.h>

#define MAX_VOLUME_SIZE 256

int main(){

	DWORD sectorsPerCluster;
	DWORD bytesPerSector;
	DWORD numberOfFreeClusters;
	DWORD totalNumberOfClusters;
	char tipo[7];

	char volumeName[MAX_VOLUME_SIZE];
	char volumes[MAX_VOLUME_SIZE];
	char * volumeAux;

	GetLogicalDriveStrings(MAX_VOLUME_SIZE, volumes);
	volumeAux = volumes;

	printf("Drive Information Utility - by Edans Flavius - 2002\n\n");

	printf("+--------+--------------+------------------+");
	printf("--------------+--------+\n");

	printf("| Volume | Bytes/Sector |  Sectors/Cluster |");
	printf(" Cluster/Size |  Type  |\n");

	printf("+--------+--------------+------------------+");
	printf("--------------+--------+\n");

	while(*volumeAux != '\0'){
		GetDiskFreeSpace(volumeAux, &sectorsPerCluster
				, &bytesPerSector
				, &numberOfFreeClusters
				, &totalNumberOfClusters);

		switch(GetDriveType(volumeAux)){
			case DRIVE_REMOVABLE:
				strcpy(tipo, "FLOPPY");
				break;
			case DRIVE_FIXED:
				strcpy(tipo, "  HD  ");
				break;
			case DRIVE_CDROM:
				strcpy(tipo, "  CD  ");
				break;
			default:
				strcpy(tipo, "  ??  ");
				break;
		}

		

		printf("| %3s    | %8d     | %10d       | %8d     | %s |\n",
				volumeAux, bytesPerSector, sectorsPerCluster
				,sectorsPerCluster*bytesPerSector, tipo);
		printf("+--------+--------------+------------------+");
		printf("--------------+--------+\n");

		

		volumeAux += strlen(volumeAux)+1;
	} ;
	
	printf("Press any key...");

	// if you dont have conio.h, delete the next line
	// and remove the #include<conio.h> in the beggining
	// of the file
	getch();

	return 0;
}
